#include <iostream>
#include <cuda.h>
using namespace std;

__global__ void checkNum(unsigned long long* result, unsigned long long iteration)
{
		int check = 0;
		for(int c = 1; c < 21; c++)
		{
			if((threadIdx.x + iteration*1000) % c == 0 && ((threadIdx.x + iteration*1000) != 0))
			{
				check++;
			}
		}
		if(check == 20)
		{
			*result = threadIdx.x + iteration*1000;
		}
}
int main()
{
	cout << "CUDA IMPLEMENTATION" << endl;
	unsigned long long* m_host, *m_device;
	unsigned long long u = 0;

	m_host = (unsigned long long*)calloc(1000,sizeof(unsigned long long));
	*m_host = 0;

	cudaMalloc(&m_device, 1000*sizeof(unsigned long long));
	cudaMemcpy(m_device, m_host, 1000*sizeof(unsigned long long), cudaMemcpyHostToDevice);

	for(unsigned long long i = 1; ; i++)
	{
		checkNum<<<1,1000>>>(m_device, i);
		cudaMemcpy(m_host, m_device, 1000*sizeof(unsigned long long), cudaMemcpyDeviceToHost);
		
		for(int z = 0; z < 1000; z++)
			if(m_host[z] != 0)
			{
				u = m_host[z];
				break;
			}
		if(u!=0)
			break;
	}

	cout << u  << endl;

	cudaFree(m_device);
	free(m_host);
	system("PAUSE");
	return 0;
}